static const char version[] = "$Id$";

/*
 * layout.c
 *
 * Copyright 2001-2003, Meiosys (www.meiosys.com). All rights reserved.
 *
 * See the COPYING file for the terms of usage and distribution.
 */

#include <log4c/layout.h>
#include <sd/sprintf.h>
#include <stdio.h>
#include <string.h>

/*******************************************************************************/
static const char* test_format(
    const log4c_layout_t*  	a_layout,
    const log4c_logging_event_t*a_event)
{
    static char buffer[1024];

    snprintf(buffer, sizeof(buffer), "logging %d bytes.\n",  strlen(a_event->evt_msg));
    return buffer;
}

/*******************************************************************************/


#ifdef __GNUC__
const log4c_layout_type_t log4c_layout_type_test = {
    name:	"test",
    format:	test_format,
};
log4c_layout_type_define(log4c_layout_type_test);
#else
#ifdef __sun
const log4c_layout_type_t log4c_layout_type_test = {
  "test",
  test_format,
};
#pragma init (__log4c_init_layout_type_log4c_layout_type_test)
static void __log4c_init_layout_type_log4c_layout_type_test(void)
{ log4c_layout_type_set(&log4c_layout_type_test); }
#endif
#endif


